package com.machint.automation;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;

import org.springframework.core.io.InputStreamResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;
import org.testng.TestListenerAdapter;
import org.testng.TestNG;
import org.testng.collections.Lists;

import com.machint.automation.model.FormObject;

@RestController
public class AutomationController {
	
	//local
	//private static final String FILE_LOCATION = "D:\\M_Automation\\MAF\\TestNGXML\\";
	//private static final String REPORT_FILE_LOCATION = "D:\\M_Automation\\MAF\\TestReport\\";
	//Server
	private static final String FILE_LOCATION = "MAF/TestNGXML/";
	private static final String REPORT_FILE_LOCATION = "MAF/TestReport/";
	public static FormObject formObject;
	
	
	@PostMapping(path="/run_test",  consumes = {MediaType.APPLICATION_FORM_URLENCODED_VALUE})
	public String runTest(FormObject formData) {
		formObject = formData;
		System.out.println(formData);
		TestListenerAdapter tla = new TestListenerAdapter();
		TestNG testng = new TestNG();
		List<String> suites = Lists.newArrayList();
		suites.add(FILE_LOCATION+formData.getTestCase());//path to xml..
		//suites.add("c:/tests/testng2.xml");
		testng.setTestSuites(suites);
		testng.addListener(tla);
		testng.run();
		
		return "Test Ran Successfully";
	}
	
//	
		
	@GetMapping(value = "/get_xml_report")
    public ResponseEntity<InputStreamResource> getXmlReport() throws IOException {
		byte[] filedata = Files.readAllBytes(Paths.get(REPORT_FILE_LOCATION+"Test-Automaton-Report.html"));
		ByteArrayInputStream in = new ByteArrayInputStream(filedata);
		HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Disposition", "attachment; filename=report.html");
		return ResponseEntity
                .ok()
                .headers(headers)
                .body(new InputStreamResource(in));
	}
	
}
