package com.machint.automation.StepDefinition;

import org.testng.annotations.Test;

import com.machint.automation.AutomationController;
import com.machint.automation.PageObject.ERF_PageObject;
import com.machint.automation.model.FormObject;

import cucumber.api.java.en.And;
import cucumber.api.java.en.Given;
import cucumber.api.java.en.When;

public class ERFSteps extends ERF_PageObject 
{
	@Test
	@Given("^User navigate to Pega Portal$")
	public void user_navigate_to_Pega_Portal() throws Throwable 
	{
		FormObject formData = AutomationController.formObject;
		launchBrowser(formData.getBrowser(),formData.getEnvironment());
	}
	@Test
	@When("^User enter project manager username and password$")
	public void user_enter_project_manager_username_and_password() throws Throwable
	{	readExcel("Pega");
		String username = Machint_TestDataFromExcel("Username");
	    Machint_EnterTextField("name", Username , username , "visibilityOf");
	    
	    String password = Machint_TestDataFromExcel("Password"); 		
 		Machint_EnterTextField("name", Password, password, "visibilityOf");
	}
	@Test
	@And("^Click on login button$")
	public void click_on_login_button() throws Throwable 
	{
	    Machint_Click("xpath", Login, "visibilityOf");
	}
	@Test
	@And("^User verify the project manager home page title$")
	public void user_verify_the_project_manager_home_page_title() throws Throwable 
	{
		Machint_getTitle("DManager");
	}
	@Test
	@And("^Click on Employee Requisition Form ERF$")
	public void click_on_Employee_Requisition_Form_ERF() throws Throwable 
	{
	    Machint_Click("xpath", ERF, "visibilityOf");
	}
	@Test
	@And("^User entered ERF code details$")
	public void user_entered_ERF_code_details() throws Throwable
	{
		Machint_Frame_webElement("xpath", IFrame, "visibilityOf");
		
		String position = Machint_TestDataFromExcel("Username");
	    Machint_EnterTextField("xpath", Position, position, "visibilityOf");
	    
	    String no_of_positions = Machint_TestDataFromExcel("No of Positions");
	    Machint_EnterTextField("id", No_of_Positions , no_of_positions, "visibilityOf");
	    
	    String client_project = Machint_TestDataFromExcel("Client/ Project");
	    Machint_EnterTextField("id", Client_Project , client_project, "visibilityOf");
	   
	    String projectID = Machint_TestDataFromExcel("Project ID");
	    Machint_EnterTextField("id", Project_ID , projectID, "visibilityOf");
	    
	    String department = Machint_TestDataFromExcel("Department");
	    Machint_EnterTextField("id", Department , department, "visibilityOf");
	    
	    String location = Machint_TestDataFromExcel("Location");
	    Machint_EnterTextField("id", Location , location, "visibilityOf");
	    
	    String external_hiring = Machint_TestDataFromExcel("External Hiring");
	    Machint_selectValue("id", External_Hiring , external_hiring, "visibilityOf");
	   
	    String reason_for_request = Machint_TestDataFromExcel("Reason for Request");
	    Machint_EnterTextField("id", Reason_for_Request , reason_for_request, "visibilityOf");
	    
	    String salary_range = Machint_TestDataFromExcel("Salary Range");
	    Machint_selectValue("id", Salary_Range , salary_range, "visibilityOf");
	    
	    String reporting = Machint_TestDataFromExcel("Reporting");
	    Machint_EnterTextField("id", Reporting , reporting, "visibilityOf");
	    
	    String target_date_to_fill = Machint_TestDataFromExcel("Target Date to Fill");
	    Machint_EnterTextField("className", Target_Date_to_Fill , target_date_to_fill, "visibilityOf");    
	    
	    Machint_Click("xpath", Laptop, "visibilityOf");
	    Machint_Click("xpath", Bag, "visibilityOf");
	    Machint_Click("xpath", HRIS, "visibilityOf");
	}
	@Test
	@And("^User entered the Job Specifications details$")
	public void user_entered_the_Job_Specifications_details() throws Throwable 
	{
		String job_responsibilities = Machint_TestDataFromExcel("Job Responsibilities");
	    Machint_EnterTextField("id", Job_Responsibilities, job_responsibilities, "visibilityOf");
	    
	    String special_accountabilities = Machint_TestDataFromExcel("Special Accountabilities or Typical Goals");
	    Machint_EnterTextField("name", Special_Accountabilities, special_accountabilities, "visibilityOf");
	    
	    String additional_inputs_to_roles = Machint_TestDataFromExcel("Additional Inputs to Roles");
	    Machint_EnterTextField("id", Additional_Inputs_to_Roles, additional_inputs_to_roles, "visibilityOf");    
	}
	@Test
	@And("^User entered the Competencies Required details$")
	public void user_entered_the_Competencies_Required_details() throws Throwable 
	{
		String practice = Machint_TestDataFromExcel("Practice");
		Machint_selectVisibleText("id", Practice, practice, "visibilityOf");
	    
	    String domain = Machint_TestDataFromExcel("Domain");
	    Machint_selectVisibleText("name", Domain, domain, "visibilityOf");
	    
	    String is_certification_required = Machint_TestDataFromExcel("Is Certification Required");
	    Machint_selectVisibleText("id", Is_Certification_Required,  is_certification_required, "visibilityOf");  
	    
	    String certifications = Machint_TestDataFromExcel("Certifications");
	    Machint_selectVisibleText("id", Certifications, certifications, "visibilityOf");  
	    
	    String technical_competency = Machint_TestDataFromExcel("Technical Competency");
	    Machint_EnterTextField("xpath", Technical_Competency, technical_competency, "visibilityOf");
	    
	    String behavioural_competency = Machint_TestDataFromExcel("Behavioural Competency");
	    Machint_selectVisibleText("xpath", Behavioural_Competency, behavioural_competency, "visibilityOf");
	    
	    String qualification = Machint_TestDataFromExcel("Qualification");
	    Machint_selectVisibleText("xpath", Qualification, qualification, "visibilityOf");  
	    
	    String overall_experience_in_years = Machint_TestDataFromExcel("Overall Experience In Years");
	    Machint_selectVisibleText("xpath", Overall_Experience_In_Years, overall_experience_in_years, "visibilityOf");  
	    
	    String relevant_experience_in_years = Machint_TestDataFromExcel("Overall Experience In Years");
	    Machint_selectVisibleText("xpath", Relevant_Experience_In_Years, relevant_experience_in_years, "visibilityOf");  
	}
	@Test
	@And("^User clicks on project manager submit button$")
	public void user_clicks_on_project_manager_submit_button() throws Throwable 
	{
	    Machint_Click("xpath", Submit,  "visibilityOf");
	}
	@Test
	@And("^Project manager page display the message$")
	public void project_manager_page_display_the_message() throws Throwable
	{
	   
	}
	@Test
	@And("^In project manager page click on logoff$")
	public void in_project_manager_page_click_on_logoff() throws Throwable 
	{
	    
	}
}
