package com.machint.automation.StepDefinition;

import org.testng.annotations.Test;

import com.machint.automation.AutomationController;
import com.machint.automation.PageObject.HR_login_PageObject;
import com.machint.automation.model.FormObject;

import cucumber.api.java.en.And;
import cucumber.api.java.en.Given;
import cucumber.api.java.en.Then;
import cucumber.api.java.en.When;

public class HR_LoginSteps extends HR_login_PageObject
{
	
	@Test
	@Given("^user navigate to Machint Walk-In Drive Portal$")
	public void user_navigate_to_Machint_Walk_In_Drive_Portal() throws Throwable 
	{
		FormObject formData = AutomationController.formObject;
		launchBrowser(formData.getBrowser(),formData.getEnvironment());
	}
	
	@Test
	@When("^user verify the homepage title$")
	public void user_verify_the_homepage_title() throws Throwable
	{
		Machint_getTitle("Mach");
	}
	@Test
	@Then("^user entered the username and password in walk-in portal$")
	public void user_entered_the_username_and_password_in_walkin_portal() throws Exception
	{
		readExcel("HR_Login");
		
	 	String username = Machint_TestDataFromExcel("Username");
	 	Machint_EnterTextField("id", Employee_Email , username,"visibilityOf");
	 	
	 	String password = Machint_TestDataFromExcel("Password"); 		
 		Machint_EnterTextField("id", Password, password, "visibilityOf");
	}
	@Test
	@And("^user click on login button$")
	public void user_click_on_login_button() throws Throwable
	{
		Machint_Click("xpath", Login, "visibilityOf");
	}
	@Test
	@Then("^login successfully after display the search from$")
	public void login_successfully_after_display_the_search_from() throws Throwable 
	{
		Machint_getTitle("Machint");
	}
	@Test
	@And("^user click on Profiles$")
	public void user_click_on_Profiles() throws Throwable 
	{
		Machint_Click("xpath", Profiles, "visibilityOf");
		Machint_getTitle("Machint");
		
	}
	@Test
	@And("^user select from and to dates$")
	public void user_select_from_and_to_dates() throws Throwable 
	{	
		String  from = Machint_TestDataFromExcel("From");
		Machint_EnterTextField("xpath", From, from, "visibilityOf");
		
		String  to = Machint_TestDataFromExcel("To");
		Machint_EnterTextField("xpath", To, to, "visibilityOf");
	}
	@Test
	@And("^user click on submit button$")
	public void user_click_on_submit_button() throws Throwable
	{
		Machint_Click("xpath", Submit, "visibilityOf");
	}
	@Test
	@Then("^display the particular from and to date data$")
	public void display_the_particular_from_and_to_date_data() throws Throwable
	{
		Machint_getTitle("Machint");
	}
	@Test
	@And ("^search the profile id$")
	public void search_the_profile_id() throws Throwable
	{
		Machint_EnterTextField("xpath", Search, "P0021", "visibilityOf");
	}
	@Test
	@And("^check the that particular profile id$")
	public void check_the_that_particular_profile_id() throws Throwable
	{
		Machint_Click("css", Check, "visibilityOf");
	}
	@Test
	@And("^click on shortlist button$") 
	public void click_on_shortlist_button() throws Throwable
	{
		Machint_Click("xpath", Shortlist, "visibilityOf");
	}
	@Test
	@Then("^display the alert message$")
	public void display_the_alert_message() throws Throwable
	{
		Machint_acceptAlert();
	}
	@Test
	@And("^user click on search icon$")
	public void user_click_on_search_icon() throws Throwable
	{
		Machint_mouseHover(Search_Icon);
		Machint_Click("xpath", Search_Icon,"visibilityOf");
	}
	@Test
	@And("^user verify search page url$")
	public void user_verify_search_page_url() throws Throwable
	{
		Machint_getTitle("Mach");
	}
	@Test
	@And("^user entered the Search Form details$")
	public void  user_entered_the_Search_Form_details() throws Exception
	{

		String HiringPlan = Machint_TestDataFromExcel("HiringPlan");
		Machint_selectValue("xpath", Hiring_Plan, HiringPlan, "visibilityOf");
		
		String CandidateShortlisted= Machint_TestDataFromExcel("Candidate Shortlisted");
		Machint_selectValue("xpath", Candidate_Shortlisted, CandidateShortlisted,"visibilityOf");
		
	 	String HighestQualification = Machint_TestDataFromExcel("Highest Qualification");
	 	Machint_EnterTextField("id", Highest_Qualification, HighestQualification, "visibilityOf");
	 
	 	String specialization = Machint_TestDataFromExcel("Specialization");
	 	Machint_EnterTextField("id", Specialization, specialization, "visibilityOf");
	
	 	String percentage = Machint_TestDataFromExcel("Percentage");
	 	Machint_EnterTextField("id", Percentage, percentage, "visibilityOf");
	 
	 	String YearOfPassing = Machint_TestDataFromExcel("Year Of Passing");
	 	Machint_EnterTextField("name", Year_Of_Passing, YearOfPassing, "visibilityOf");
	
	 	String KnowledgeInJAVA = Machint_TestDataFromExcel("Knowledge In JAVA");
	 	Machint_selectValue("id", Knowledge_In_JAVA, KnowledgeInJAVA, "visibilityOf");
	
	 	String KnowledgeInPEGA = Machint_TestDataFromExcel("Knowledge In PEGA");
	 	Machint_selectValue("id", Knowledge_In_PEGA, KnowledgeInPEGA, "visibilityOf");
		
	 	String KnowledgeInAPPIAN = Machint_TestDataFromExcel("Knowledge In APPIAN");
	 	Machint_selectValue("xpath", Knowledge_In_APPIAN, KnowledgeInAPPIAN, "visibilityOf");
	 	
	 	String KnowledgeInRPA = Machint_TestDataFromExcel("Knowledge In RPA");
	 	Machint_selectVisibleText("id", Knowledge_In_RPA, KnowledgeInRPA, "visibilityOf");
 	
	 	String KnowledgeInPYTHON = Machint_TestDataFromExcel("Knowledge In PYTHON");
	 	Machint_selectVisibleText("id", Knowledge_In_PYTHON, KnowledgeInPYTHON, "visibilityOf");
		
	 	String KnowledgeInDATABASE = Machint_TestDataFromExcel("Knowledge In DATABASE");
	 	Machint_selectVisibleText("xpath", Knowledge_In_DATABASE, KnowledgeInDATABASE, "visibilityOf");
	}
	@Test
	@And("^user click on search button$")
	public void user_click_on_search_button() throws Throwable
	{
		Machint_Click("xpath", Search_btn, "visibilityOf");
	}
	@Test
	@And ("^search the profile id in search from$")
	public void search_the_profile_id_in_search_from() throws Throwable
	{
		Machint_EnterTextField("xpath", Search, "P0210", "visibilityOf");
	}
	@Test
	@And("^check the that particular profile id in search from$")
	public void check_the_that_particular_profile_id_in_search_from() throws Throwable
	{
		Machint_Click("xpath", Check_SearchFrom, "visibilityOf");
	}
	@Test
	@And("^user click on Shortlist$")
	public void user_click_on_Shortlist() throws Throwable
	{
		Machint_Click("xpath", Shortlist, "visibilityOf");
	}
	@Test
	@Then("^display the alert messgae in search form$")
	public void display_the_alert_message_in_search_form() throws Throwable
	{
		Machint_acceptAlert();
	}
	@Test
	@And("^user click on download selected$")
	public void user_click_on_download_selected() throws Throwable
	{
		Machint_Click("xpath", Search_btn, "visibilityOf");
		Machint_EnterTextField("xpath", Search, "P0210", "visibilityOf");
		Machint_Click("xpath", Check_SearchFrom, "visibilityOf");
//		Machint_Click("xpath", DownloadSelected, "visibilityOf");
	}
	@Test
	@And("^user click on send mail")
	public void user_click_on_send_mail() throws Throwable
	{
		Machint_Click("xpath", Send_Mail, "visibilityOf");
	}
	@Test
	@And("^user click on logout icon")
	public void user_click_on_logout_icon() throws Throwable
	{
		Machint_Click("xpath", Logout, "visibilityOf");
		driver.close();
	}	
	
}
