package com.machint.automation.StepDefinition;

import org.testng.annotations.Test;

import com.machint.automation.AutomationController;
import com.machint.automation.PageObject.Insurance_PageObject;
import com.machint.automation.model.FormObject;

import cucumber.api.java.en.And;
import cucumber.api.java.en.Given;
import cucumber.api.java.en.Then;
import cucumber.api.java.en.When;

public class InsuranceSteps extends Insurance_PageObject
{
	@Test
	@Given("^user navigate to parthenon page$")
	public void user_navigate_to_parthenon_page() throws Throwable
	{
		FormObject formData = AutomationController.formObject;
		launchBrowser(formData.getBrowser(),formData.getEnvironment());
	}
	@Test
	@When("^user validates homepage title$")
	public void user_validates_homepage_title() throws InterruptedException
	{
		Machint_FutureDate();
		Machint_getTitle("Appian for Rainbow Digital Marketing &amp; Analytics Pte Ltd (DEV)");
	}
	@Test
	@Then("^user entered the username and password$")
	public void user_entered_the_username_and_password() throws Throwable 
	{
		readExcel("Insurance");
		
		String username = Machint_TestDataFromExcel("Username");
		Machint_EnterTextField("id", Username, username, "visibilityOf");
		
		String password = Machint_TestDataFromExcel("Password");
		Machint_EnterTextField("id", Password, password, "visibilityOf");
	}
	@Test
	@And("^user click on signin button$")
	public void user_click_on_signin_button() throws Throwable
	{
		Machint_Click("xpath", Signin, "visibilityOf");
	}
	@Test
	@Then("^parthenon page should be displayed$")
	public void parthenon_page_should_be_displayed() throws InterruptedException 
	{
		Machint_getTitle("HOME - Parthenon");
	}
	
	//Actions
	@Test
	@Given("^user click on actions$")
	public void user_click_on_actions() throws Throwable 
	{
		Machint_Click("xpath", Actions, "visibilityOf");	
	}
	@Test
	@When("^user validates action page$")
	public void user_validates_action_page() throws Throwable 
	{
		Machint_getTitle("//Actions - Parthenon");
	}
	@Test
	@And("^user click on Case management$")
	public void user_click_on_Case_management() throws Throwable 
	{
		Machint_Click("xpath", Case_management, "visibilityOf");
	}
	@Test
	@And("^user create case in case management$")
	public void user_create_case_in_case_management() throws Throwable
	{
		String LineOfBusiness = Machint_TestDataFromExcel("Line of business");
		Machint_EnterTextKey("xpath", Line_of_business, LineOfBusiness, "visibilityOf");
		
		String ProductCategory = Machint_TestDataFromExcel("Product category");
		Machint_EnterTextKey("xpath", Product_category, ProductCategory, "visibilityOf");
		
		String product = Machint_TestDataFromExcel("Product");
		Machint_EnterTextKey("xpath", Product , product, "visibilityOf");
	}
	@Test
	@And ("^after select the product catalogue in SH - Advanced table click on select button$")
	public void after_select_the_product_catalogue_in_SH_Advanced_table_click_on_select_button() throws Throwable
	{
		Machint_Click("xpath", Select, "visibilityOf");
	}
	@Test
	@And("^click on continue button$")
	public void click_on_continue_button() throws Throwable
	{
		Machint_Click("xpath", Continue, "visibilityOf");
	}
	@Test
	@And("^click on add customer button$")
	public void click_on_add_customer_button() throws Throwable
	{
		Machint_Click("xpath", Add_customer, "visibilityOf");
	}
	@Test
	@Then("^in SH-Advanced Personal Details page displayed$")
	public void in_SH_Advanced_Personal_Details_page_displayed() throws InterruptedException
	{
		Machint_getTitle("PA Customer On-Boarding - Parthenon//");
	}
	@Test
	@And("^user enter personal details$")
	public void user_enter_personal_details() throws Throwable
	{
		String title = Machint_TestDataFromExcel("Title");
		Machint_EnterTextKey("xpath", Title , title, "visibilityOf");
		
		String first_name = Machint_TestDataFromExcel("First Name");
		Machint_EnterTextField("xpath", First_name , first_name, "visibilityOf");
		
		String middle_name = Machint_TestDataFromExcel("Middle Name");
		Machint_EnterTextField("xpath", Middle_name , middle_name, "visibilityOf");
		
		String last_name = Machint_TestDataFromExcel("Last Name");
		Machint_EnterTextField("xpath", Last_name , last_name, "visibilityOf");
		
		String customer_type = Machint_TestDataFromExcel("Customer Type");
		Machint_EnterTextKey("xpath", Customer_type , customer_type, "visibilityOf");
		
		String mobile_number = Machint_TestDataFromExcel("Mobile Number");
		Machint_EnterTextField("xpath", Mobile_number , mobile_number, "visibilityOf");
		
		String email = Machint_TestDataFromExcel("Email");
		Machint_EnterTextField("xpath", Email , email, "visibilityOf");
		
		String date_of_birth = Machint_TestDataFromExcel("Date Of Birth");
		Machint_EnterTextField("xpath", Date_of_birth  , date_of_birth, "visibilityOf");

		Machint_Click("xpath", Gender, "visibilityOf");

		Machint_Click("xpath", Un_married, "visibilityOf");
	}

	@Test
	@And("^click on add new row in family details$")
	public void click_on_add_new_row_in_family_details() throws Throwable
	{
	   Machint_Click("xpath", Add_new_row, "visibilityOf");
	}
	@Test
	@And("^user enter family details$")
	public void user_enter_family_details() throws Throwable 
	{
		String title = Machint_TestDataFromExcel("Family Details Title");
		Machint_EnterTextKey("xpath", FamilyDetails_title, title, "visibilityOf");
		
		String relation_type = Machint_TestDataFromExcel("Family Details Relation Type");
		Machint_EnterTextKey("xpath", FamilyDetails_Relation_Type, relation_type, "visibilityOf");
		
		String first_name = Machint_TestDataFromExcel("Family Details First Name");
		Machint_EnterTextField("xpath", FamilyDetails_first_name, first_name, "visibilityOf");
		
		String last_name = Machint_TestDataFromExcel("Family Details Last Name");
		Machint_EnterTextField("xpath", FamilyDetails_last_name, last_name, "visibilityOf");
		
		String middle_name = Machint_TestDataFromExcel("Family Details Middle Name");
		Machint_EnterTextField("xpath", FamilyDetails_middle_name, middle_name, "visibilityOf");

		String gender = Machint_TestDataFromExcel("Family Details Gender");
		Machint_EnterTextKey("xpath", FamilyDetails_gender, gender, "visibilityOf");
		
		String date_of_birth = Machint_TestDataFromExcel("Family Details Date Of Birth");
		Machint_EnterTextField("xpath", FamilyDeatils_date_of_birth, date_of_birth, "visibilityOf");
		
		String mobile_number = Machint_TestDataFromExcel("Family Details Mobile Number");
		Machint_EnterTextField("xpath", FamilyDetails_mobile_number, mobile_number, "visibilityOf");
	}
	@Test
	@And("^click on next button$")
	public void click_on_next_button() throws Throwable 
	{
	   Machint_Click("xpath", Next, "visibilityOf");
	}
	@Test
	@Then("^KYC documents page displayed$")
	public void KYC_documents_page_displayed() throws Throwable
	{
		driver.close();
	}
}
