package com.machint.automation.Utils;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Set;

import org.openqa.selenium.Alert;
import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.Keys;
import org.openqa.selenium.NoAlertPresentException;
import org.openqa.selenium.NoSuchElementException;
import org.openqa.selenium.NoSuchFrameException;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.Select;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import com.machint.automation.base.BaseClass;

public class ActionClass extends BaseClass
{
	public static WebElement element;
	public static By by, locator;
	public static Select select;
	public static WebDriverWait wait;
	public static Actions action;
	public static String actual, actualValue;
    public static Boolean flag;
    public static Alert alert ;
    
	public static By Machint_locator(String locatorType, String LocatorValue) 
	{
		switch (locatorType)
		{
		case "id":
			by = By.id(LocatorValue);
			break;
			
		case "name":
			by = By.name(LocatorValue);
			break;
			
		case "className":
			by = By.className(LocatorValue);
			break;
			
		case "tagName":
			by = By.tagName(LocatorValue);
			break;
			
		case "xpath":
			by = By.xpath(LocatorValue);
			break;
			
		case "css":
			by = By.cssSelector(LocatorValue);
			break;
			
		case "linkText":
			by = By.linkText(LocatorValue);
			break;
			
		case "partialLinkText":
			by = By.partialLinkText(LocatorValue);
			break;
			
		default:
			by = null;
			break;
		}
		return by;
	}
	
	public static void Machint_EnterTextKey(String LocatorType, String LocatorValue, String value, String WaitType) throws Exception 
	{	
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			
			Machint_Waits(WaitType);
			element.click();
			element.sendKeys(value);
			element.sendKeys(Keys.ENTER);
			Machint_JSHighlight(element);
		    Thread.sleep(2000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_EnterTextKey \t" + e);
		}
	}

	public static void Machint_EnterTextField(String LocatorType, String LocatorValue, String value, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			element.clear();
		    element.sendKeys(value);
		    Thread.sleep(2000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_EnterTextField \t" + e);
		}
	}
	
	public static void Machint_Click(String LocatorType, String LocatorValue, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			element.click();
		    Thread.sleep(3000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to perform Machint_Click \t" + e);
		}
	}
	
	public static void Machint_contextClick(String LocatorType, String LocatorValue, String WaitType) throws Exception
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			action=new Actions(driver);
			action.contextClick(element).build().perform();
			Thread.sleep(1000);
		}
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to perform Machint_DoubleClick \t" + e);
		}
	}
	
	public static void Machint_doubleClick(String LocatorType, String LocatorValue, String WaitType) throws Exception
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			action=new Actions(driver);
			action.moveToElement(element).doubleClick().build().perform();
			Thread.sleep(1000);
		}
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to perform Machint_DoubleClick \t" + e);
		}
	}
	
	public static void Machint_clickAndHold(String LocatorType, String LocatorValue, String WaitType) throws Exception
	{
		try 
		{
			action = new Actions(driver);
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);	
			action.clickAndHold(element).build().perform();
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);			
			element.click();
		    Thread.sleep(3000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to perform Machint_ClickAndHoldAction\t" + e);
		}
	}
	
	public static void Machint_selectValue(String LocatorType, String LocatorValue, String text, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			select = new Select(element);
			select.selectByValue(text);
			Thread.sleep(1000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_selectValue \t" + e);
		}
	}
	
	public static void Machint_selectIndex(String LocatorType, String LocatorValue, int value, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			select = new Select(element);
			select.selectByIndex(value);
			Thread.sleep(1000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_selectIndex \t" + e);
		}
	}
	
	public static void Machint_selectVisibleText(String LocatorType, String LocatorValue, String text, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_JSHighlight(element);
			Machint_Waits(WaitType);
			select = new Select(element);
			select.selectByVisibleText(text);
			Thread.sleep(1000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_selectVisibleText \t" + e);
		}
	}
	
	public static void Machint_Waits(String WaitType) throws Exception  
	{
		switch (WaitType)
		{
		case "visibilityOf":
			Machint_visibilityOf();
			break;
			
		case "visibilityOfAllElements":
			Machint_visibilityOfAllElements();
			break;
		
		case "elementToBeClickable":
			Machint_elementToBeClickable();
			break;
		
		case "elementToBeSelected":
			Machint_elementToBeSelected();
			break;
			
		case "elementSelectionStateToBe":
			Machint_elementSelectionStateToBe();
			break;
			
		case "frameToBeAvailableAndSwitchToIt":
			Machint_frameToBeAvailableAndSwitchToIt();
			break;
		
		case "invisibilityOf":
			Machint_invisibilityOf();
			break;

		case "invisibilityOfAllElements":
			Machint_invisibilityOfAllElements();
			break;
	
		default:
			System.out.println(WaitType+ " is invalid");
		}
	}
	
	public static void Machint_visibilityOf()
	{
		try
		{	
			wait = new WebDriverWait(driver, 1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.visibilityOf(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_visibilityOf \t" + e);
		}
	}

	public static void Machint_visibilityOfAllElements()
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.visibilityOfAllElements(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_visibilityOfAllElements \t" + e);
		}
	}
	
	public static void Machint_elementToBeClickable() 
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.elementToBeClickable(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_elementToBeClickable \t" + e);
		}
	}
	
	public static void Machint_elementSelectionStateToBe() 
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.elementSelectionStateToBe(element, flag));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_elementSelectionStateToBe \t" + e);
		}
	} 
	
	public static void Machint_elementToBeSelected() 
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.elementToBeSelected(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_elementToBeSelected \t" + e);
		}
	} 
	
	public static void Machint_frameToBeAvailableAndSwitchToIt()
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.frameToBeAvailableAndSwitchToIt(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_frameToBeAvailableAndSwitchToIt \t" + e);
		}
	}
	
	public static void Machint_invisibilityOf()
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(by != null)
			{
				wait.until(ExpectedConditions.invisibilityOf(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_invisibilityOf \t" + e);
		}
	}
	
	public static void Machint_invisibilityOfAllElements()
	{
		try 
		{
			wait = new WebDriverWait(driver,1000);	
			if(element != null)
			{
				wait.until(ExpectedConditions.invisibilityOfAllElements(element));
			}
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to Machint_invisibilityOfAllElements \t" + e);
		}
	}
	
	public static void Machint_JSHighlight(WebElement ele) 
	{
		if (driver instanceof JavascriptExecutor) 
		{
			((JavascriptExecutor) driver).executeScript("arguments[0].setAttribute('style', 'background: skyblue; border: 2px solid yellow;');",ele);
		}
	}
	
	public static boolean Machint_acceptAlert()
	{
		  boolean boolFound = false;
			try
	        {
				wait = new WebDriverWait(driver, 1000);
				wait.until(ExpectedConditions.alertIsPresent());
	           alert = driver.switchTo().alert();
	          if (alert != null)
	          {
	            alert.accept();
	            boolFound = true;
	          }
	        }
	        catch (NoAlertPresentException ex) 
			{
	        	boolFound = false;
				ex.printStackTrace();
			}
			return boolFound;
	}
	
	public static boolean Machint_dismissAlert()
	{
		  boolean boolFound = false;
			try
	        {
				wait = new WebDriverWait(driver, 1000);
				wait.until(ExpectedConditions.alertIsPresent());
	           alert = driver.switchTo().alert();
	          if (alert != null)
	          {
	            alert.dismiss();
	            boolFound = true;
	          }
	        }
	        catch (NoAlertPresentException ex) 
			{
	        	boolFound = false;
				ex.printStackTrace();
			}
			return boolFound;
			
	}
		
	public static boolean Machint_getAlertText()
	{
		  boolean boolFound = false;
			try
	        {
			 wait = new WebDriverWait(driver, 1000);
			 wait.until(ExpectedConditions.alertIsPresent());
	          alert = driver.switchTo().alert();
	          String AlertMsg=driver.switchTo().alert().getText();
	          if (alert != null)
	          {
	            alert.accept();
	            System.out.println(AlertMsg);
	            boolFound = true;
	          }
	        }
	        catch (NoAlertPresentException ex) 
			{
	        	boolFound = false;
				ex.printStackTrace();
			}
			return boolFound;
			
	}
	
	public static void Machint_getTitle(String Expected)
	{
		String Title = driver.getTitle();
		Assert.assertEquals(Title, Expected);
	}
	
	public static String Machint_AssertEquals(String LocatorType, String LocatorValue, String expectedValue)
	{
		locator = Machint_locator(LocatorType, LocatorValue);
		actualValue =  driver.findElement(locator).getText();	
		System.out.println("Actual Value is \t"+actualValue);
		Assert.assertEquals(actualValue, expectedValue);
		return actualValue;
	}
	
	public static boolean Machint_NotEquals_Validation(String LocatorType,String LocatorValue, String expected)
	{
		locator = Machint_locator(LocatorType, LocatorValue);
		String element = driver.findElement(locator).getText();
		flag = false;
		if(element != null)
		{
			Assert.assertNotEquals(element, expected);
			flag = true;
		}
	else 
			
		{
			 System.out.println("Actual Value and Expected Value Matched");
		}
		return flag;
	}
	
	public static boolean Machint_True_Validation(String LocatorType,String LocatorValue, String expected)
	{
		 locator = Machint_locator(LocatorType, LocatorValue);
		 boolean condition = driver.findElement(locator).getText() != null;
		 	flag = false;
		 
		 if(element != null)
		 {
			 Assert.assertTrue( condition, expected);
		 	flag = true;
		 	System.out.println(flag);
		 }
		 else
		 {
			System.err.format("Validation is not performed");
		}
		return flag;
	}
	
	public static boolean Machint_False_Validation(String LocatorType,String LocatorValue, String expected)
	{
		try
		{
		 locator = Machint_locator(LocatorType, LocatorValue);
		 boolean condition = driver.findElement(locator).getText() != null;
		 	flag = false;
		 
		 if(element != null)
		 {
			 Assert.assertFalse( condition, expected);
		 	flag = true;
		 	System.out.println(flag);
		 }
		}
		catch (NoSuchElementException e) 
		{ 
			System.err.format("Validation is not performed");
		}
		return flag;
	}
	
	public static void Machint_mouseHover(String LocatorValue) throws Throwable
	{
			action = new Actions(driver);
			element = driver.findElement(By.xpath(LocatorValue));
			action.moveToElement(element).build().perform();
	}
	
	public static void Machint_Frame_webElement(String LocatorType, String LocatorValue, String WaitType) throws Exception 
	{
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			Machint_Waits(WaitType);
			driver.switchTo().frame(element);
		    Thread.sleep(2000);
		} 
		catch (NoSuchElementException e) 
		{
			System.err.format("No Element Found to perform Machint_Frame \t" + e);
		}
	}
	
	public void Machint_switchToFrame(String ParentFrame, String ChildFrame)
	{
		try 
			{
				driver.switchTo().frame(ParentFrame).switchTo().frame(ChildFrame);
			}
		catch (NoSuchFrameException e) 
			{
				System.out.println("Unable to locate frame with id " + ParentFrame + " or " + ChildFrame + e.getStackTrace());
			} 
		catch (Exception e) 
			{
				System.out.println("Unable to navigate to innerframe with id "+ ChildFrame + "which is present on frame with id"+ParentFrame + e.getStackTrace());
			}
	}
	
	public static void Machint_defaultframe()
	{
		try
			{
			driver.switchTo().defaultContent();
			}
		catch (Exception e) 
			{
			System.out.println("unable to navigate back to parent frame"+e.getStackTrace());
			}
	}
	
	public static void Machint_windowhandle()
	{
		String Parent=driver.getWindowHandle();
			Set<String>s=driver.getWindowHandles();
			Iterator<String> I1= s.iterator();

			while(I1.hasNext())
			{
				String child_window=I1.next();
				if(!Parent.equals(child_window))
				{
					driver.switchTo().window(child_window);
					System.out.println(driver.switchTo().window(child_window).getTitle());
					driver.close();
				}
			}
	}
	
	public static void Machint_YesterdayDate()
	{
		DateFormat sdf = new SimpleDateFormat("MM/dd/YYYY"); 
//		Calendar today = Calendar.getInstance();
		Calendar yesterday = Calendar.getInstance();
		yesterday.add(Calendar.DATE, -1);
		Date d = yesterday.getTime(); // get a Date object
		String yesDate = sdf.format(d); // toString for Calendars is mostly not really useful
		System.out.println("Yesterday Date is \t"+yesDate);
	}
	
	public static void Machint_CurrentDate()
	{
		DateFormat sdf = new SimpleDateFormat("dd/MM/YYYY"); 
		Date date = new Date();
		String Date = sdf.format(date);
		System.out.println("Current Date is\t"+Date);
	}
	
	public static void Machint_FutureDate()
	{
		DateFormat sdf = new SimpleDateFormat("MM/dd/YYYY"); 
		Calendar futureDate = Calendar.getInstance();
		futureDate.add(Calendar.DATE, 7);
		Date date = futureDate.getTime();
		String Date = sdf.format(date);
		System.out.println("Future Date is\t"+Date);
	}
	
	public static void Machint_CurrentMonth()
	{
		int month;
		Calendar cal = Calendar.getInstance();
		month = cal.get(Calendar.MONTH);
        month = month+1;
        System.out.println("Current month is  " + month);
	}
	
	public static void Machint_CurrentYear()
	{
		int year;
		Calendar cal = Calendar.getInstance();
		year = cal.get(Calendar.YEAR);
        System.out.println("Current year is  " + year);	
	}
	
	public static void Machint_getToolTip() throws Exception
	{
		// Get tooltip text
		String toolTipText = element.getAttribute("title").toString();
		System.out.println("Tool tip text present :- " + toolTipText);

		// Compare toll tip text
//		Assert.assertEquals(toolTipText, expectedValue);
	}
	
	public static Boolean Machint_DragandDropby(String LocatorType, String LocatorValue, int x, int y) throws Exception
	{
		boolean flag = false;
		try
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			element = driver.findElement(locator);
			action=new Actions(driver);
			action.dragAndDropBy(element, x, y).build().perform();
			flag = true;
			return flag;
		}
		catch (Exception e) 
		{
			return false;
		}
	}
	
	public boolean isCheckBoxSelected(String LocatorType, String LocatorValue) throws Throwable
	{
		boolean flag = false;
		try 
		{
			locator = Machint_locator(LocatorType, LocatorValue);
			if (driver.findElement(locator).isSelected()) {
			flag = true;
		}
			return flag;
	
		} 
		catch (NoSuchElementException e) 
		{
			flag = false;
			return flag;
		}
	}
	
}
