package com.machint.automation.Utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class ExcelData
{  
	static XSSFCell cell, cell0;
	static XSSFSheet sheet;
	static XSSFWorkbook excelWorkbook;
	static XSSFRow row;
	static String filePath =  "MAF/testdatafolder/TestData.xlsx";
	static File file;
	static FileInputStream inputFile;
	static FileOutputStream outputFile;
	static int rowcount;
	static int i,j;
	public static String cellValue, celldata;
	
	  public static void readExcel(String sheetName) throws Exception
		{
			file = new File(filePath);
			FileInputStream inputStream = new FileInputStream(file);
	 	   	excelWorkbook = new XSSFWorkbook(inputStream);    
	 	   	sheet = excelWorkbook.getSheet(sheetName);
		 }
     
	  public static int getRowCount() 
		{
			int rowcount =  sheet.getLastRowNum();
			return rowcount;				
		}
		
		public static int getColumnCount()
		   {
		       row = sheet.getRow(0);
		       int colCount = row.getLastCellNum();
		       return colCount;
		   }

		public static String getCellContentAsString(Cell cell) throws Exception
	    {    
	        switch (cell.getCellType())
	        {

	        case Cell.CELL_TYPE_BLANK:
	            celldata="";
	            break;

	        case Cell.CELL_TYPE_STRING:
	            celldata=cell.getStringCellValue();
	            break;

	        case Cell.CELL_TYPE_NUMERIC:
	            DataFormatter df=new DataFormatter();
	            celldata=df.formatCellValue(cell);
	            break;

	        case Cell.CELL_TYPE_FORMULA:
	            celldata=String.valueOf(cell.getNumericCellValue());
	            break;

	        case Cell.CELL_TYPE_BOOLEAN:
	            celldata=String.valueOf(cell.getBooleanCellValue());
	            break;

	        default:
	            celldata=cell.getStringCellValue();
	            break;
	        }
	        return celldata;
	    }
		
		public static String getCellData(int rowcount, int ColNum) throws Exception
		{
			String result = null;
		
		    cell = sheet.getRow(rowcount).getCell(ColNum);	    
		    result = getCellContentAsString(cell);
			return result;
		}		
		
		public static String Machint_TestDataFromExcel(String ColumnName) throws Exception
		{	
			     for(i=1;i<=getRowCount() ; i++)
		     	{		 
					row = sheet.getRow(i);
			  		cell=row.getCell(0);
			  	    String Actionvalue = cell.getStringCellValue();
			  		 if(Actionvalue.equalsIgnoreCase(ColumnName))
					    {
				  			 cell = sheet.getRow(i).getCell(1);
				  			 cellValue = getCellContentAsString(cell);
			     	    }		     		
		     	}	
	  		return cellValue;
	    }
		
		public static String Machint_TestDataFromExcelFile(String ColumnName) throws Exception
		{	
			try
			{

		        int totalNoOfRows = sheet.getLastRowNum() - sheet.getFirstRowNum();
		        row = sheet.getRow(0);
		        HashMap<String, String> map = new HashMap<String, String>();

		        for (int row2 = 1; row2 < totalNoOfRows; row2++) {

		            Row row1 = sheet.getRow(row2);
		            if ((row1.getCell(0).getStringCellValue()).equals(ColumnName)) {
		                for (int col = 1; col < row1.getLastCellNum(); col++) 
		                {
		                    map.put(row.getCell(col).getStringCellValue(), row1.getCell(col).getStringCellValue());
		                }
		            }
		            System.out.println(map);

		        }
		    } catch (Exception e) {
		        e.printStackTrace();
		    }
			return cellValue;
	    }
	  			
		
				public static List<LinkedHashMap<String, String>> getExcelDataAsMap() throws Exception
				{
					// Initialized an empty List which retain order
					List<LinkedHashMap<String, String>> dataList = new ArrayList<>();
					// Get data set count which will be equal to cell counts of any row
					int countOfDataSet = sheet.getRow(0).getPhysicalNumberOfCells();
					// Skipping first column as it is field names
					for (int i = 1; i < countOfDataSet; i++) 
					{
						System.out.println("Number of countOfDataSet \t"+countOfDataSet);
						// Creating a map to store each data set individually
						LinkedHashMap<String, String> data  = new LinkedHashMap<>();
						// Get the row i.e field names count
						int rowCount = sheet.getPhysicalNumberOfRows();
						System.out.println("Row count is \t"+rowCount);
						// Now we need to iterate all rows but cell should increases once all row is done
						// i.e. (1,1),(2,1),(3,1),(4,1),(5,1) - First iteration
						//      (1,2),(2,2),(3,2),(4,2),(5,2) - Second iteration
						//      (1,3),(2,3),(3,3),(4,3),(5,3) - Third iteration
						for(int j = 1; j<rowCount ; j++) 
						{
							row = sheet.getRow(j);
							// Field name is constant as 0th index
//							cell = row.getCell(0);
//							String fieldName = getCellContentAsString(cell);
							String fieldName = row.getCell(0).getStringCellValue();
							
							System.out.println("Excel field name is \t"+fieldName);
							
							cell = row.getCell(i);
							String fieldValue = getCellContentAsString(cell);
							
							System.out.println("Excel field Value is \t"+fieldValue);
							// Add data in map
							data.put(fieldName, fieldValue);
							
						}
						// Add map to list after each iteration
						dataList.add(data);
						
					}
					return dataList;
				}
			 
//				public static void main(String[] args) throws EncryptedDocumentException, IOException 
//				{
//			 
//					List<LinkedHashMap<String, String>> mapDataList = getExcelDataAsMap();
//					
//					for(int k = 0; k<mapDataList.size() ; k++)
//					{
//						System.out.println("Data Set "+ (k+1) +" : ");
//						for(String s: mapDataList.get(k).keySet())
//						{
//							System.out.println("Value of "+s +" is  : "+mapDataList.get(k).get(s));
//						}
//						System.out.println("========================================================");
//					}
//				}

}
		 
	